/* ---------------------------------------------------------------------------------
 * Capture de signaux et execXX()
 * Jean-Paul Rigault 
 * ---------------------------------------------------------------------------------
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <signal.h>
#include <stdlib.h>

/* Une fonction qui cre un fils excutant le programme tst_exec_signal-aux.exe
 * et lui envoie SIGINT 
 */
void Exec()
{
    pid_t pid;

    if ((pid = fork()) != 0)
    {
        /* Pre */

        /* On attent que le fils dmarre */
        sleep(1); 

        kill(pid, SIGINT);
        wait(0);
    }
    else 
    {
        /* Fils */

        execl("./tst_exec_signal-aux.exe", "tst_exec_signal-aux", NULL);
        perror("exec");
        exit(0);
    }
}

void on_int(int sig)
{
    printf("signal %d\n", sig);
}

int main()
{
    printf("Le pre ignore SIGINT: le fils doit aller jusqu'au bout (5 secondes)\n");
    signal(SIGINT, SIG_IGN);
    Exec();

    printf("Le pre trappe SIGINT: le fils meurt immdiatement (signal rtabli  l'action par dfaut)\n");
    signal(SIGINT, on_int);
    Exec();

    printf("Le pre remet SIGINT  l'action par dfaut: le fils meurt immdiatement\n");
    signal(SIGINT, SIG_DFL);
    Exec();

    return 0;    
}
